unit Unit3;

interface

uses windows, graphics;

const OFN_EXPLORER = $00080000;
      OFN_NONETWORKBUTTON = $00020000;
      OFN_HIDEREADONLY = $00000004;
      b1x=7;   //    
      b1y=7;
      b1w=75;
      b1h=25;
      b2x=7;
      b2y=40;
      b2w=75;
      b2h=25;
      
type
 poin = record
  x,y:extended; // . 
  dx,dy:extended;//   
 end;

 trgb = record  //,      ,     
  b,g,r: byte;
 end;

 ARGB = array [0..0] of TRGB;
 PARGB = ^ARGB;

 tagOFNA = packed record
   lStructSize: DWORD;
   hWndOwner: HWND;
   hInstance: HINST;
   lpstrFilter: PAnsiChar;
   lpstrCustomFilter: PAnsiChar;
   nMaxCustFilter: DWORD;
   nFilterIndex: DWORD;
   lpstrFile: PAnsiChar;
   nMaxFile: DWORD;
   lpstrFileTitle: PAnsiChar;
   nMaxFileTitle: DWORD;
   lpstrInitialDir: PAnsiChar;
   lpstrTitle: PAnsiChar;
   Flags: DWORD;
   nFileOffset: Word;
   nFileExtension: Word;
   lpstrDefExt: PAnsiChar;
   lCustData: LPARAM;
   lpfnHook: function(Wnd: HWND; Msg: UINT; wParam: WPARAM; lParam: LPARAM): UINT stdcall;
   lpTemplateName: PAnsiChar;
 end;

var
  MainWND:thandle;
  hFontBold: THandle;
  WC: TWndClass;
  Mesg:TMsg;
  but1,but2: THandle;

  sour: tbitmap; //,   
  px,py: integer; //    
  prevx, prevy: integer; //    
  dragtrig: boolean = false;
  ps,pr:array of PARGB;  //       Pointer Sours, Pointer Result
  shad:integer;
  orw,orh:integer; //      
  points: array of poin;
  activ, trig, rn:boolean;//    
  wrt,grt,r1,r2:trect;   //Work RecT (  ) Graphic RecT
  count:cardinal;
  Thr: longword;
  ofn: tagOFNA;
  oFilterIndex: DWORD;

function GetMid(t:trect):trgb;

implementation

function GetMid(t:trect):trgb;
 var i,j:integer;
     r,g,b:int64;
begin
 r:=0;
 g:=0;
 b:=0;
 for i:=t.Top to t.Bottom do
  for j:=t.Left to t.Right do begin
   r:=r+ps[i,j].r;
   g:=g+ps[i,j].g;
   b:=b+ps[i,j].b;
  end;
 i:=(t.Bottom-t.Top+1)*(t.Right-t.Left+1);
 result.r:=r div i;
 result.g:=g div i;
 result.b:=b div i;
end;

end.
 